## castle-game-engine 7.0~alpha.3%2Bdfsg2

=== Makefile ===
# Makefile to build and perform other useful operations on the Castle Game Engine.
#
# Requires using GNU make.
# - On Linux and most other Unixes, just call "make".
# - On FreeBSD call "gmake".
# - On Windows, install Cygwin ( http://www.cygwin.com/ ) with "make" package.
#   Make sure that when you type "make" it executes Cygwin's "make":
#   Cygwin's directory (like c:/cygwin64/bin/) should be on $PATH environment variable
#   *before* other directories with "make" implementations, like
#   - FPC directory that includes "make" from MinGW (it is GNU make but cannot execute bash scripts)
#   - Delphi directory that includes Embarcadero "make" (it's not GNU make and will fail).
#
# Most useful targets of this Makefile:
#
#   default (default target) --
#     Build the most useful things:
#     - tools not depending on LCL (including build tool)
#     - editor
#     Also, register all Lazarus packages.
#     Also, place all tools and editor in bin/ subdirectory.
#
#   tools --
#     Build all tools that don't depend on LCL.
#     Right now it means: all tools except castle-editor.
#
#   examples --
#     Compile most examples and tools (that don't use Lazarus LCL).
#     Lazarus is not required (LCL dependent examples are not compiled).
#
#     This compilation method calls our "build tool" to compile examples
#     and other tools (build tool, in turn, calls a compiler like FPC or Delphi).
#
#     The exception is when compiling the "build tool" itself,
#     then we call FPC directly. (Although we *could* use
#     the "build tool" to compile (bootstrap) itself, but it's not what
#     people expect by default, so we don't do it for now.)
#
#   examples-laz --
#     Compile all examples and tools using Lazarus (lazbuild).
#     This compilation method uses our .lpi project files,
#     and compiles every program by the lazbuild utility.
#     Lazarus and FPC installation is required.
#
#   build-using-fpmake:
#     Compile all units using FpMake.
#     We support this as an optional build approach to CGE and applications using CGE.
#     See https://castle-engine.io/fpmake .
#
#   clean --
#     Delete FPC temporary files, Delphi temporary files,
#     Lazarus temporary files (*.compiled),
#     binaries of example programs and tools.

# detect platform-specific things --------------------------------------------

# FIND := Unix/Cygwin "find" utility (*not* Windows "find" command which has completely different use)
# SED := GNU sed (*not* other sed implementations)
# EXE_EXTENSION := extension of executable files (with leading dot, if any)

SED := sed
FIND := find
INSTALL := install
EXE_EXTENSION :=

# Detect Windows when $OS is Windows_NT or win64.
# Other $OS, including when $OS is empty / undefined, must be non-Windows.
# See https://stackoverflow.com/questions/7656425/makefile-ifeq-logical-or#9802777
# to how this trick to detect an alternative works.
ifneq (,$(filter $(OS),Windows_NT win64))
  $(info Detected OS: Windows)

  # On Windows avoid using Windows built-in "find" program. Use the Cygwin "find".
  FIND := `cygpath --mixed /bin/find`
  EXE_EXTENSION := .exe
else
  # Only on Unix, you can use "uname" to further detect Unix variants,
  # see https://stackoverflow.com/questions/714100/os-detecting-makefile
  UNAME_S := $(shell uname -s)
  $(info Detected OS: $(UNAME_S))

  # On macOS, use gsed and ginstall (e.g. from Homebrew, use "brew install gnu-sed coreutils").
  # See https://www.topbug.net/blog/2013/04/14/install-and-use-gnu-command-line-tools-in-mac-os-x/
  # http://www.legendu.net/en/blog/install-gnu-utils-using-homebrew/
  ifeq ($(UNAME_S),Darwin)
    SED := gsed
    INSTALL := ginstall
  endif
endif

# config ---------------------------------------------------------------------

# By default, use build tool compiled by tools/build-tool/castle-engine_compile.sh .
# This is easy, and when not cross-compiling, things will just work out-of-the-box,
# Makefile will always first build the build tool, then use it.
#
# You can override it on the command-line like "make BUILD_TOOL=castle-engine"
# to use build tool on $PATH .
# This is more reliable in some scenarios:
#
# - We will use build tool for current (source) system, even if CASTLE_FPC_OPTIONS
#   uses -T${OS} -P${CPU} to indicate a different (target) system,
#   so castle-engine_compile.sh doesn't build for current system.
#
# - Build tool can exist outside of CGE, and thus it exists regardless of "make clean" etc.
#
BUILD_TOOL = ./tools/build-tool/castle-engine$(EXE_EXTENSION)

# compiling tools ------------------------------------------------------------

.PHONY: default
default: tools
	lazbuild $(CASTLE_LAZBUILD_OPTIONS) --add-package-link packages/castle_base.lpk
	lazbuild $(CASTLE_LAZBUILD_OPTIONS) --add-package-link packages/castle_window.lpk
	lazbuild $(CASTLE_LAZBUILD_OPTIONS) --add-package-link packages/castle_components.lpk
	lazbuild $(CASTLE_LAZBUILD_OPTIONS) --add-package-link packages/castle_editor_components.lpk
	lazbuild $(CASTLE_LAZBUILD_OPTIONS) tools/castle-editor/castle_editor.lpi
# move binaries to bin/
	$(INSTALL) -d bin/
	$(INSTALL) tools/texture-font-to-pascal/texture-font-to-pascal$(EXE_EXTENSION) bin/
	$(INSTALL) tools/image-to-pascal/image-to-pascal$(EXE_EXTENSION) bin/
	$(INSTALL) tools/castle-curves/castle-curves$(EXE_EXTENSION) bin/
	$(INSTALL) tools/build-tool/castle-engine$(EXE_EXTENSION) bin/
	$(INSTALL) tools/to-data-uri/to-data-uri$(EXE_EXTENSION) bin/
	$(INSTALL) tools/castle-editor/castle-editor$(EXE_EXTENSION) bin/

.PHONY: tools
tools:
# Compile build tool first, used to compile other tools and examples
	tools/build-tool/castle-engine_compile.sh
	$(BUILD_TOOL) $(CASTLE_ENGINE_TOOL_OPTIONS) --project tools/castle-curves/ compile
	$(BUILD_TOOL) $(CASTLE_ENGINE_TOOL_OPTIONS) --project tools/image-to-pascal/ compile
	$(BUILD_TOOL) $(CASTLE_ENGINE_TOOL_OPTIONS) --project tools/texture-font-to-pascal/ compile
	$(BUILD_TOOL) $(CASTLE_ENGINE_TOOL_OPTIONS) --project tools/to-data-uri/ compile

# install / uninstall --------------------------------------------------------
#
# Note that this *does not* take care of installing the unit files.
# So it does not copy .ppu/.o files, it does not change your /etc/fpc.cfg
# or ~/.fpc.cfg. There are many ways how to install unit files,
# we leave this step up to you.
# See https://castle-engine.io/engine.php for documentation.
#
# Below we only take care of installing the tools.
# By default they are installed system-wide to /usr/local ,
# so you can run "make" followed by "sudo make install" to have the tools
# ready on a typical Unix system.

# Standard installation dirs, following conventions on
# http://www.gnu.org/prep/standards/html_node/Directory-Variables.html#Directory-Variables
PREFIX=$(DESTDIR)/usr/local
EXEC_PREFIX=$(PREFIX)
BINDIR=$(EXEC_PREFIX)/bin
DATAROOTDIR=$(PREFIX)/share
DATADIR=$(DATAROOTDIR)

.PHONY: install
install:
	echo 'Installing tools to $(BINDIR)'
	$(INSTALL) -d $(BINDIR)
	$(INSTALL) tools/texture-font-to-pascal/texture-font-to-pascal$(EXE_EXTENSION) $(BINDIR)
	$(INSTALL) tools/image-to-pascal/image-to-pascal$(EXE_EXTENSION) $(BINDIR)
	$(INSTALL) tools/castle-curves/castle-curves$(EXE_EXTENSION) $(BINDIR)
	$(INSTALL) tools/build-tool/castle-engine$(EXE_EXTENSION) $(BINDIR)
	$(INSTALL) tools/to-data-uri/to-data-uri$(EXE_EXTENSION) $(BINDIR)
#	cp -R tools/build-tool/data $(DATADIR)/castle-engine
	echo 'Installing data to $(DATADIR)/castle-engine/'
	$(INSTALL) -d  $(DATADIR)
	cd tools/build-tool/data/ && \
	  "$(FIND)" . -type f -exec $(INSTALL) --mode 644 -D '{}' $(DATADIR)/castle-engine/'{}' ';'

.PHONY: uninstall
uninstall:
	rm -f  $(BINDIR)/texture-font-to-pascal$(EXE_EXTENSION) \
	       $(BINDIR)/image-to-pascal$(EXE_EXTENSION) \
	       $(BINDIR)/castle-curves$(EXE_EXTENSION) \
	       $(BINDIR)/castle-engine$(EXE_EXTENSION) \
	       $(BINDIR)/to-data-uri$(EXE_EXTENSION)
	rm -Rf $(DATADIR)/castle-engine

# Strip libraries that cannot be distributed in Debian package of CGE.
# - Some of them (some bundled Windows, Android libs) cannot be recompiled
#   automatically and easily for now (although they are open-source),
#   and are not of sufficient interest to the Debian users.
# - Some (Gradle) should be better used by depending on
#   the appropriate Debian package.
.PHONY: strip-precompiled-libraries
strip-precompiled-libraries:
	rm -Rf tools/build-tool/data/external_libraries/ \
	       tools/build-tool/data/android/integrated-services/sound/ \
	       tools/build-tool/data/android/integrated-services/ogg_vorbis/ \
	       tools/build-tool/data/android/integrated-services/freetype/ \
	       tools/build-tool/data/android/base/gradle/ \
	       tools/build-tool/data/android/base/gradlew \
	       tools/build-tool/data/android/base/gradlew.bat \
	       tools/build-tool/data/android/integrated/gradle/ \
	       tools/build-tool/data/android/integrated/gradlew \
	       tools/build-tool/data/android/integrated/gradlew.bat

# compiling examples -----------------------------------------------------------

# For GitHub Actions, we need to conserve disk space in some cases, as it is limited to ~15 GB.
#
# When CASTLE_CONSERVE_DISK_SPACE is
# - true -> prefixing command with $(DO_IF_CONSERVE_DISK_SPACE) makes this command execute.
# - anything else -> prefixing command with $(DO_IF_CONSERVE_DISK_SPACE) makes this command not execute.
#
ifeq ($(CASTLE_CONSERVE_DISK_SPACE),true)
DO_IF_CONSERVE_DISK_SPACE:=
else
DO_IF_CONSERVE_DISK_SPACE:=true
endif

# Note that examples with CastleEngineManifest.xml are not listed here.
# They will be found and compiled by a Makefile rule that searches using
# "find ... -iname CastleEngineManifest.xml ..." .

EXAMPLES_BASE_NAMES :=

# Note that src/deprecated_library/castleengine must be compiled before
# cge_dynlib_tester, otherwise linking cge_dynlib_tester will fail.
EXAMPLES_LAZARUS_BASE_NAMES := \
  src/deprecated_library/castleengine \
  examples/deprecated_library/lazarus_library_tester/cge_dynlib_tester

EXAMPLES_UNIX_EXECUTABLES := $(EXAMPLES_BASE_NAMES) \
  $(EXAMPLES_LAZARUS_BASE_NAMES)

EXAMPLES_WINDOWS_EXECUTABLES := $(addsuffix .exe,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .exe,$(EXAMPLES_LAZARUS_BASE_NAMES))

# Test compiling single CGE editor template.
# Requires CGE_TEMPLATE to be defined.
.PHONY: test-editor-template
test-editor-template:
	rm -Rf temporary-test-projects
	$(BUILD_TOOL) $(CASTLE_ENGINE_TOOL_OPTIONS) create test-project --project-parent-dir temporary-test-projects --project-template $(CGE_TEMPLATE)
	$(BUILD_TOOL) $(CASTLE_ENGINE_TOOL_OPTIONS) --project temporary-test-projects/test-project compile
	rm -Rf temporary-test-projects

# Test compiling CGE editor templates
.PHONY: test-editor-templates
test-editor-templates:
	$(MAKE) --no-print-directory test-editor-template CGE_TEMPLATE=3d_fps_game
	$(MAKE) --no-print-directory test-editor-template CGE_TEMPLATE=2d_game
	$(MAKE) --no-print-directory test-editor-template CGE_TEMPLATE=empty
	$(MAKE) --no-print-directory test-editor-template CGE_TEMPLATE=3d_model_viewer

.PHONY: examples
examples:
# Compile build tool first, used to compile other tools and examples.
	tools/build-tool/castle-engine_compile.sh

# Compile all examples and tools with CastleEngineManifest.xml inside.
#
# We want this to fail if some application failed to compile.
# Unfortunately find seems to ignore -exec result.
# (see e.g. https://unix.stackexchange.com/questions/392970/how-to-get-the-exit-code-of-commands-started-by-find )
# And we cannot use -execdir.
# We also cannot use find ... | xargs, we need to execute 2 commands for each (compile and clean).
#
# So we use find to generate list of projects, then run using simple "for" over them.
#
# Exceptions: We do not process:
#
# - examples/network/tcp_connection/: because it requires Indy which may not be installed.
#
# - tests/delphi_tests: because it requires Delphi, which is not available on non-Windows.
#

=== doc/pasdoc/Makefile ===
# Main targets to gen final docs ----------------------------------------

# Avoid using WSL bash on GH-hosted runner windows-latest,
# by explicitly using GIT (MSys) bash.
# Note: Setting SHELL doesn't help.
#
# This is a hack, after a long fight with it -- no idea why this specific
# Makefile (but not others) seems to try to execute WSL bash in this sitiuation.
# Various tests on GH hosted runner with this script and mingw32-make,
# /c/mingw64/bin/make resulted in various weird errors
# (like make segfaulting, or "cp" not finding a dir that "ls" shows exists...).
# This seems like the most local workaround that reliably avoids the problem.
ifdef WINDOWS_FORCE_GIT_BASH
  $(info Detected OS: Windows, using Git bash as SHELL)
  #BASH:=gitbash # not found
  BASH:="C:/Program Files/Git/bin/bash.exe"
else
  BASH:=bash
endif

.PHONY: default html pdf latex php

# html is shown on https://castle-engine.io/apidoc/html/
default: html

# Run "make" in logo/ first,
# if you have inkscape installed,
# and you want to regenerate logo from png.
#
# Run "make" in html-parts/ first,
# if you have cge-www repository (https://github.com/castle-engine/cge-www)
# cloned and placed as a sibling to castle-engine, in ../../../cge-www/

html:
	$(BASH) ./mk_docs.sh html
# For quick testing of docs look (CSS etc.), you can run this instead
#	./mk_docs.sh html base/castleutils.pas
	rm -Rf ../reference/
	mv html ../reference/
	cp -R logo/castle_game_engine_icon.png \
	      html-parts/images/ \
	      html-parts/castle-engine-website-base/ \
	      html-parts/cge-pasdoc.js \
	      ../reference/

# Just some shortcuts to "Helpful targets" below
latex: latex/docs.tex
pdf: latex/docs.pdf

# Helpful targets to gen docs ----------------------------------------

latex/docs.tex:
	$(BASH) ./mk_docs.sh latex

TEX_BATCH_OPTS := --file-line-error-style -interaction=nonstopmode

# At the end of pdf generating, we clean useless junk
# (because it's quite large, and I may want to upload latex/
# dir to WWW page of my units)
latex/docs.pdf: latex/docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	rm -f latex/docs.aux \
	      latex/docs.log \
	      latex/docs.out \
	      latex/docs.toc

# PHP update -----------------------------------------------------------------

# Generate PHP map, copy it to cge-www repo (you should commit it there).
.PHONY: php
php:
	$(BASH) ./mk_docs.sh php
	cp -f php/docs.php ../../../cge-www/htdocs/apidoc_map_latest.php

# Cleaning ------------------------------------------------------------

.PHONY: clean-cache clean

clean-cache:
	rm -fR cache/

clean: clean-cache
	rm -Rf html/ latex/ php/ ../reference/

# upload ---------------------------------------------------------------------
#
# This "upload" command is not used by anything (like GitHub Actions) now.
# It is only useful for manual upload of the docs to the server by michalis,
# in case of emergency (e.g. when the automatic upload fails).

SSH_USERNAME=michalis
SSH_HOST=ssh.castle-engine.io
SSH_PATH=/home/michalis/cge-html/apidoc/

# Prepare and upload all the stuff referenced under
# https://castle-engine.io/apidoc/html/ .
# Uploads as tar.gz and unpacks on server, this is *much* faster than
# uploading separate HTML files.
.PHONY: upload
upload: clean html
	rm -Rf ../reference/html
	mv ../reference/ html
	tar czf html.tar.gz html
	scp -r html.tar.gz $(SSH_USERNAME)@$(SSH_HOST):$(SSH_PATH)
	rm -f html.tar.gz
	./ssh_upload_finalize.sh $(SSH_USERNAME) $(SSH_HOST) $(SSH_PATH)

=== tests/egl_sizes_test/Makefile ===
egl_sizes_test: egl_sizes_test.c
	$(CC) -o $@ $<

=== doc/man/man1/Makefile ===
.PHONY: default
default:
	./generate.sh

.PHONY: clean
clean:
	rm -f *.1

=== doc/pasdoc/html-parts/Makefile ===
# Use this Makefile to generate HTML files
# for inclusion in the HTML API documentation.
#
# It requires
# - command-line php
# - cge-www repository (https://github.com/castle-engine/cge-www)
#   cloned and placed as a sibling to castle-engine, in ../../../../cge-www/

ALL_TARGETS := body-end.html body-begin.html head.html images castle-engine-website-base

.PHONY: default
default: $(ALL_TARGETS)

.PHONY: clean
clean:
	rm -Rf $(ALL_TARGETS)

%.html: %.php
	php $< > $@

# Copy some static things (images, CSS, JS files) from cge-www.

CGE_WWW_PATH := ../../../../cge-www/

images:
	rm -Rf images
	mkdir -p images
	cp -Rf $(CGE_WWW_PATH)htdocs/images/header_icon.png \
	       $(CGE_WWW_PATH)htdocs/images/patreon-brand \
	       images/
# The $(CGE_WWW_PATH)htdocs/images/castle_game_engine_icon* are symlinks now,
# copy instead the actual files to make things simple for distributing these API docs.
	cp -f  $(CGE_WWW_PATH)htdocs/images/not_resized_original/castle_game_engine_icon.png \
	       images/
	cp -f  $(CGE_WWW_PATH)htdocs/images/not_resized_original/castle_game_engine_icon_fit_in_square.png \
	       images/

castle-engine-website-base:
	rm -Rf castle-engine-website-base
	mkdir -p castle-engine-website-base
	cp -Rf $(CGE_WWW_PATH)htdocs/castle-engine-website-base/castle-engine.css \
	       $(CGE_WWW_PATH)htdocs/castle-engine-website-base/castle-asciidoctor.css \
	       $(CGE_WWW_PATH)htdocs/castle-engine-website-base/castle-engine.js \
	       $(CGE_WWW_PATH)htdocs/castle-engine-website-base/node_modules \
	       castle-engine-website-base/

=== examples/deprecated_library/cpp_winapi_library_tester/Makefile ===
# Compile using g++ for Windows. Works at least with g++ from Cygwin.
#
# Note: if you're compiling a 64-bit application,
# make sure that castleengine.dll is also compiled for 64-bit.
# You may want tc run ../../../src/deprecated_library/castleengine_compile.sh
# with the -Twin64 -Px86_64 options to force this (since often
# the default fpc compiles for Windows 32-bit).

# Do not link to castleengine.dll this way,
# instead use dynamic loading in ../../../src/deprecated_library/castlelib_c_loader.cpp
#LINKFLAGS:=-L../../../src/deprecated_library/ -lcastleengine

# Do not use -lWs2_32, instead use -mwindows following https://cygwin.com/cygwin-ug-net/programming.html
# This works also on 64-bit.
#LINKFLAGS:=-lWs2_32

LINKFLAGS:=-lopengl32

cpp_winapi_library_tester: main.cpp
	g++ $< ../../../src/deprecated_library/castlelib_c_loader.cpp -mwindows $(LINKFLAGS) -o $@

.PHONY: run
run:
	cp -f ../../../src/deprecated_library/castleengine.dll .
	./cpp_winapi_library_tester.exe

=== src/scene/glsl/Makefile ===
# Generate Pascal include files from all GLSL code in source/ .
#
# Uses file_to_pascal_string, which is part of PasDoc. See:
# - PasDoc main webpage:
#   https://github.com/pasdoc/pasdoc/wiki
# - file_to_pascal_string trivial source code (you can just get this one file and compile it yourself):
#   https://github.com/pasdoc/pasdoc/blob/master/source/tools/file_to_pascal_string.dpr
#
# Placing source/ and generated-pascal/ in separate subdirectories makes it easier
# to browse, and to grep inside GLSL files, since you can easily grep only within source/ .
#
# Note that we flatten directory structure in generated-pascal/,
# to avoid the need to specify many include paths.
# It just seems easier to extend and reorganize the source/ directory freely this way.

ifneq (,$(filter $(OS),Windows_NT win64))
  $(info Detected OS: Windows)
  # Hack for Cygwin, to avoid using Windows built-in "find" program.
  FIND:=`cygpath --mixed /bin/find`
else
  $(info Detected OS: not Windows)
  FIND:=find
endif

ALL_SOURCES := $(shell $(FIND) source/ \
  -iname '*.fs' -or \
  -iname '*.vs' -or \
  -iname '*.gs' -or \
  -iname '*.glsl')
ALL_OUTPUT := $(addsuffix .inc, \
  $(subst lighting_model_phong/,lighting_model_phong_, \
  $(subst lighting_model_physical/,lighting_model_physical_, \
  $(subst lighting_model_unlit/,lighting_model_unlit_, \
  $(subst source/,generated-pascal/, \
  $(ALL_SOURCES))))))

.PHONY: all
all: $(ALL_OUTPUT)

generated-pascal/%.inc: source/%
	file_to_pascal_string $< $@
generated-pascal/lighting_model_phong_%.inc: source/lighting_model_phong/%
	file_to_pascal_string $< $@
generated-pascal/lighting_model_physical_%.inc: source/lighting_model_physical/%
	file_to_pascal_string $< $@
generated-pascal/lighting_model_unlit_%.inc: source/lighting_model_unlit/%
	file_to_pascal_string $< $@

.PHONY: clean
clean:
#	rm -f $(ALL_OUTPUT)
# Clean all *.inc files, in case we renamed some files in source/
	rm -f generated-pascal/*.inc

=== src/ui/designs/Makefile ===
# This requires file_to_pascal_string that is a trivial program
# from pasdoc project, see
# https://github.com/pasdoc/pasdoc/wiki
# https://github.com/pasdoc/pasdoc/blob/master/source/tools/file_to_pascal_string.dpr

.PHONY: all clean

ALL_OUTPUT=inspector_ui.castle-user-interface.inc

all: $(ALL_OUTPUT)

clean:
	rm -f $(ALL_OUTPUT)

%.inc: %
	file_to_pascal_string $< $@

=== src/ui/gui-images/Makefile ===
.PHONY: all clean

ALL_UNITS=../castleinternalcontrolsimages.pas

all: $(ALL_UNITS)

clean:
	rm -f $(ALL_UNITS)

../castleinternalcontrolsimages.pas: Panel.png PanelSeparator.png \
  Tooltip.png TooltipRounded.png \
  ButtonPressed.png ButtonDisabled.png ButtonFocused.png ButtonNormal.png \
  WindowDark.png WindowGray.png WindowDarkTransparent.png \
  ScrollbarFrame.png ScrollbarSlider.png SliderBackground.png SliderThumb.png \
  FrameWhite.png FrameWhiteBlack.png FrameYellow.png FrameYellowBlack.png \
  FrameThickWhite.png FrameThickYellow.png \
  TouchCtlInner.png TouchCtlOuter.png TouchCtlFlyInner.png TouchCtlFlyOuter.png \
  Crosshair1.png Crosshair2.png ScrollbarSlider.png \
  SquareEmpty.png SquarePressedBackground.png SquareChecked.png \
  Loading.png Edit.png
	image-to-pascal --output .. CastleInternalControlsImages \
	  Panel.png WindowDarkTransparent.png \
	  Tooltip.png TooltipRounded.png \
	  ButtonPressed.png ButtonDisabled.png ButtonFocused.png ButtonNormal.png \
	  FrameWhite.png FrameWhiteBlack.png FrameYellow.png FrameYellowBlack.png \
	  FrameThickWhite.png FrameThickYellow.png \
	  TouchCtlInner.png TouchCtlOuter.png TouchCtlFlyInner.png TouchCtlFlyOuter.png \
	  Loading.png Crosshair1.png Crosshair2.png ScrollbarSlider.png \
	  SquareEmpty.png SquarePressedBackground.png SquareChecked.png \
	  @alpha=keep-and-bleed \
	  SliderBackground.png SliderThumb.png \
	  @alpha=strip \
	  PanelSeparator.png WindowDark.png WindowGray.png \
	  ScrollbarFrame.png Edit.png

=== tools/build-tool/embedded_images/Makefile ===
.PHONY: all clean

ALL_OUTPUTS=toolembeddedimages.pas tooldefaulticonxpm.inc

all: $(ALL_OUTPUTS)

clean:
	rm -f $(ALL_OUTPUTS)

toolembeddedimages.pas: DefaultIcon.png DefaultIconSquare.png
	image-to-pascal ToolEmbeddedImages DefaultIcon.png \
	@alpha=strip DefaultIconSquare.png

tooldefaulticonxpm.inc: DefaultIcon.xpm
	file_to_pascal_string $< $@

=== tools/build-tool/embedded_templates/Makefile ===
# This requires file_to_pascal_string that is a trivial program
# from pasdoc project, see
# https://github.com/pasdoc/pasdoc/wiki
# https://github.com/pasdoc/pasdoc/blob/master/source/tools/file_to_pascal_string.dpr

ALL_TARGETS := \
  windows/castle-automatic-windows.manifest.inc \
  template-castle-engine-output-warning.txt.inc

default: $(ALL_TARGETS)

clean:
	rm -f $(ALL_TARGETS)

%.inc: %
	file_to_pascal_string $< $@

=== tools/castle-editor/gfx/icons_on_forms/Makefile ===
# Use "make" to regenerate exported/ contents.

# ----------------------------------------------------------------------------
# Extend this section when adding new icons

# Generate single 24x24 PNG from these
SOURCE_FOR_24:=folder.svg \
  trash-2.svg

# Generate single 32x32 PNG from these
SOURCE_FOR_32:=alert-triangle.svg \
  border-all.svg \
  edit.svg \
  heart-solid.svg \
  menu.svg \
  settings.svg

# Generate multiple PNG sizes from these
SOURCE_FOR_MULTIPLE_SIZES:=pause-solid.svg \
  play-solid.svg   \
  stop-solid.svg \
  pause-solid-physics.svg \
  play-solid-physics.svg \
  stop-solid-physics.svg \
  file-plus.svg \
  info-solid.svg \
  tool-translate.svg \
  tool-rotate.svg \
  tool-scale.svg \
  tool-select.svg \
  tool-interact.svg \
  list.svg \
  grid.svg

# ----------------------------------------------------------------------------
# Implementation

OUTPUT_24:=$(patsubst %.svg,exported/%_24x24.png,$(SOURCE_FOR_24))

OUTPUT_32:=$(patsubst %.svg,exported/%_32x32.png,$(SOURCE_FOR_32))

OUTPUT_MULTIPLE_SIZES:=\
  $(patsubst %.svg,exported/%_16x16.png,$(SOURCE_FOR_MULTIPLE_SIZES)) \
  $(patsubst %.svg,exported/%_20x20.png,$(SOURCE_FOR_MULTIPLE_SIZES)) \
  $(patsubst %.svg,exported/%_24x24.png,$(SOURCE_FOR_MULTIPLE_SIZES)) \
  $(patsubst %.svg,exported/%_32x32.png,$(SOURCE_FOR_MULTIPLE_SIZES)) \
  $(patsubst %.svg,exported/%_48x48.png,$(SOURCE_FOR_MULTIPLE_SIZES))

OUTPUT_ALL:=$(OUTPUT_24) $(OUTPUT_32) $(OUTPUT_MULTIPLE_SIZES)

.PHONY: default
default: $(OUTPUT_ALL)

.PHONY: clean
clean:
	rm -Rf $(OUTPUT_ALL)

exported/%_16x16.png: %.svg
	inkscape --export-width=16 --export-height=16 $< --export-filename=$@
exported/%_20x20.png: %.svg
	inkscape --export-width=20 --export-height=20 $< --export-filename=$@
exported/%_24x24.png: %.svg
	inkscape --export-width=24 --export-height=24 $< --export-filename=$@
exported/%_32x32.png: %.svg
	inkscape --export-width=32 --export-height=32 $< --export-filename=$@
exported/%_48x48.png: %.svg
	inkscape --export-width=48 --export-height=48 $< --export-filename=$@

=== debian/changelog ===
castle-game-engine (7.0~alpha.3+dfsg2-3) unstable; urgency=medium

  * Updated patches meta description.
  * Disabled failing test on armel.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Thu, 13 Feb 2025 09:32:09 +0100

castle-game-engine (7.0~alpha.3+dfsg2-2) unstable; urgency=medium

  * Updated clean file after repacking sources.
  * Fixed dependency on FPC packages. Require version with hardening enabled.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Tue, 11 Feb 2025 00:16:07 +0100

castle-game-engine (7.0~alpha.3+dfsg2-1) unstable; urgency=medium

  * Ensure hardening is taken into account on the entire compilation process.
  * Removed unused license from copyright file.
  * Removed warning about unused entry in debian/source/include-binaries file.
  * Exclude binary files upon clean and when importing new upstream release.
  * Removed files not packaged by upstream from copyright exclude section.
  * Repack sources again version 7.0~alpha.3+dfsg2
  * Reset DFSG repack suffix in watch file for next upstream release.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 08 Feb 2025 15:13:33 +0100

castle-game-engine (7.0~alpha.3+dfsg1-12) unstable; urgency=medium

  * Fixed file pattern in copyright file.
  * Removed windows executable files upon clean.
  * Enabled hardening when building CGE.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Fri, 07 Feb 2025 19:37:19 +0100

castle-game-engine (7.0~alpha.3+dfsg1-11) unstable; urgency=medium

  * Fixed units path on armel and armhf architecture and cross compilation.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 01 Feb 2025 15:30:58 +0100

castle-game-engine (7.0~alpha.3+dfsg1-10) unstable; urgency=medium

  * Fixed tests on all targets after latest breakage.
  * Fixed Lintian warning about comma in files separated list in copyright.
  * Removed Lintian warning about redundant build prerequisite.
  * Enabled Static-Built-Using: fpc to track changes in FPC libraries.
    This should fix issue where fp-units-rtl get changes and CGE does not
    get recompiled causing issues for users.
    Fixed dependency on FPC ABI as the substitution variable was not replaced.
  * Bumped standard version and FPC version in dependencies.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 19 Jan 2025 16:51:33 +0100

castle-game-engine (7.0~alpha.3+dfsg1-9) unstable; urgency=medium

  * Fixed build on ppc64el.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Fri, 17 Jan 2025 14:02:06 +0100

castle-game-engine (7.0~alpha.3+dfsg1-8) unstable; urgency=medium

  * Fixed compilation on ppc64el.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Fri, 17 Jan 2025 09:58:51 +0100

castle-game-engine (7.0~alpha.3+dfsg1-7) unstable; urgency=medium

  * Fixed make file to ensure compilation uses packaged FPC RTL.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 13 Jan 2025 10:05:41 +0100

castle-game-engine (7.0~alpha.3+dfsg1-6) unstable; urgency=medium

  * Fixed Debian tests to use new upstream test suite. (Closes: Bug#1092309)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 12 Jan 2025 14:51:32 +0100

castle-game-engine (7.0~alpha.3+dfsg1-5) unstable; urgency=medium

  * Removed wrong chunk in a debian patch file that was added by mistake.
  * Updated copyright file.
  * Fixed dependency on fp-compiler enforcing the right minimal version.
    (Closes: Bug#1092309)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Tue, 07 Jan 2025 22:11:05 +0100

castle-game-engine (7.0~alpha.3+dfsg1-4) unstable; urgency=medium

  * Move CGE fp-units to the location recommended by FPC configuration file.
    Units are installed to Debianised location and a configuration file is
    added to FPC system wide configuration directory.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 05 Jan 2025 22:00:06 +0100

castle-game-engine (7.0~alpha.3+dfsg1-3) unstable; urgency=medium

  * Removed dependency of a particular imagemagick version.
    We pick whatever version is installed and it. (Closes: Bug#1089659)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 05 Jan 2025 12:25:59 +0100

castle-game-engine (7.0~alpha.3+dfsg1-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 01 Dec 2024 10:11:31 +0100

castle-game-engine (7.0~alpha.3+dfsg1-2) unstable; urgency=medium

  [ Niels Thykier ]
  * Migrate to debputy.
    Signed-off-by: Niels Thykier <niels@thykier.net>

  [ Abou Al Montacir ]
  * Enabled CI/CD on salsa.
  * Fixed building using fpmake.
    Thanks to Michalis Kamburelis <michalis.kambi@gmail.com>

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Tue, 22 Oct 2024 08:26:19 +0200

castle-game-engine (7.0~alpha.3+dfsg1-1) unstable; urgency=medium

  * New upstream version 7.0~alpha.3+dfsg1
  * Updated patches and removed already applied by upstream.
  * Updated rules file after upstream changes.
    Upstream does not define `cleanall` make target anymore.
    Upstream renamed tool `texture-font-to-pascal` replacing dashes by
    underscores.
    Pass fonts path to `mk_fonts.sh` when invoked from rules file.
  * Removed build dependency on inkscape.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 13 Oct 2024 08:37:02 +0200

## castle-game-engine 7.0~alpha.3+dfsg1

=== debian/control ===
Source: castle-game-engine
Section: misc
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders:
 Abou Al Montacir <abou.almontacir@sfr.fr>,
 Paul Gevers <elbrus@debian.org>
Standards-Version: 4.5.0
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-debputy (>= 0.1.14~),
 fonts-dejavu,
 fp-compiler (>= 3.2.2+dfsg-35),
 fp-units-base,
 fp-units-db,
 fp-units-fcl,
 fp-units-gfx,
 fp-units-gtk2,
 fp-units-misc,
 fp-units-multimedia,
 fp-units-net,
 fp-utils,
 help2man,
 imagemagick,
 libatk1.0-dev,
 libcairo2-dev,
 libfreetype-dev,
 libgdk-pixbuf-2.0-dev,
 libgl1,
 libgtk2.0-dev,
 libpango1.0-dev,
Build-Depends-Indep:
 fonts-dejavu,
 pasdoc (>= 0.16.0~),
Vcs-Git: https://salsa.debian.org/pascal-team/castle-game-engine.git
Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine
Homepage: https://castle-engine.sourceforge.io/engine.php
Rules-Requires-Root: no

Package: fp-units-castle-game-engine
Architecture: any
Depends:
 ${fpc-abi:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 castle-game-engine-src,
 gradle,
Description: Castle Game Engine - 3D game engine for FreePascal / Lazarus
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains the FPC units and the auxiliary tools castle-curves,
 castle-engine, image-to-pascal, sprite-sheet-to-x3d, and
 texture-font-to-pascal.
 .
 This package suggests the gradle package. Gradle is only necessary if one
 wants to build Android applications, otherwise one can ignore that
 suggestion. Note that, in order to create Android applications, one will also
 need the Android SDK and NDK, and FPC cross-compiler, see
 https://github.com/castle-engine/castle-engine/wiki/Android.

Package: castle-game-engine-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 fonts-droid-fallback,
 fonts-dejavu-core,
 libjs-bootstrap,
 libjs-jquery,
Suggests:
 castle-game-engine-src,
 fp-units-castle-game-engine,
Multi-Arch: foreign
Description: Castle Game Engine - Developer's Documentation
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains documentation.

Package: castle-game-engine-src
Section: doc
Architecture: all
Depends:
 fonts-dejavu,
 ${misc:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 fp-units-castle-game-engine
Multi-Arch: foreign
Description: Castle Game Engine - Source code for Lazarus integration
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains source code for integration with Lazarus RAD IDE.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Castle Game Engine

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
export LANG:=C

# Documentation type to use chm/html
ifeq (${DEBDOCTYPE},)
DOCTYPE=html
# HTML Converter chmdocs or htmldocs for (default)
CONVERTER=${DOCTYPE}docs
else
DOCTYPE=${DEBDOCTYPE}
CONVERTER=${DOCTYPE}docs
endif
# Define FPC
ifndef FPC
FPC=/usr/bin/fpc
endif
# Set FPCVER
FPCVER=$(shell ${FPC} -iV)

CPU_TARGET?=$(shell ${FPC} -iTP)
OS_TARGET?=$(shell ${FPC} -iTO)
FPCTARGET=${CPU_TARGET}-${OS_TARGET}
export CGE_VERSION=$(shell echo ${DEB_VERSION_UPSTREAM} | sed -e 's/^\([0-9\.]*\).*/\1/')
DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
ifndef PACKAGESUFFIX
PACKAGESUFFIX=-${CGE_VERSION}
endif
# Get directories
INSTALL_DIR=$(CURDIR)/debian/tmp
CFG_DIR=${INSTALL_DIR}/etc/fpc-${FPCVER}.cfg.d
LIB_PREFIX=${INSTALL_DIR}/usr/lib
LIB_DIR=${LIB_PREFIX}/${DEB_SOURCE}
SRC_DIR=$(CURDIR)/debian/src/${DEB_SOURCE}-${CGE_VERSION}
TMP_DIR=${INSTALL_DIR}/tmp
# Define units installation default directory as recommended by Debian FPC Team
UNITS_DIR=${LIB_PREFIX}/${DEB_HOST_MULTIARCH}/${DEB_SOURCE}/fp-units/${FPCVER}
# Get utils
ifndef MKDIR
MKDIR=mkdir -p
endif
ifndef CP
CP=cp -Rfpl
endif
RM:=rm -rf

#export DH_VERBOSE=1

%:
	dh ${@}

override_dh_auto_clean:
	${MAKE} clean
	$(MAKE) strip-precompiled-libraries
	dh_auto_clean

prepare-source: prepare-source-stamp
prepare-source-stamp:
	# Building Pascal style font file first while making sure that
	# no unit or object files polute the source tree
	${MKDIR} ${TMP_DIR}
	${FPC} -FE${TMP_DIR} @castle-fpc.cfg \
		-otexture-font-to-pascal \
		tools/texture-font-to-pascal/texture_font_to_pascal.lpr
	cd src/fonts ; PATH=${PATH}:${TMP_DIR} ./mk_fonts.sh /usr/share/fonts/truetype/dejavu

	# cge embeds some images from xcf via png into Pascal source files
	# First we need to create the pngs
	for pngfile in $$(grep \\\.png\$$ debian/clean) ; do convert -layers flatten -background transparent $${pngfile%.png}.xcf $${pngfile} ; done
	# Then we build the helper function
	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg \
		-oimage-to-pascal \
		tools/image-to-pascal/image_to_pascal.lpr
	# To finally convert png files to pas file
	PATH=${TMP_DIR} ${MAKE} -C src/ui/gui-images all

	# Upstream source contains auto-generated include files. Let's generate
	# them again.
	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg \
		-Futools/internal/x3d-nodes-to-pascal/code \
		-ox3d-nodes-to-pascal \
		tools/internal/x3d-nodes-to-pascal/x3d_nodes_to_pascal.lpr
	cd tools/internal/x3d-nodes-to-pascal/ && \
		PATH=${TMP_DIR} x3d-nodes-to-pascal \
		--input-path nodes-specification/ \
		--output-path ../../../src/scene/x3d/auto_generated_node_helpers/

	# For reproducible builds we need to make sure the timestamp of the just
	# created files is fixed. Let's use SOURCE_DATE_EPOCH for that. For the
	# future, this needs to be even smarter, because now every Debian revision
	# will require all the reverse dependencies generating ppu files to be
	# rebuild.
	touch --no-dereference --date="@$${SOURCE_DATE_EPOCH}" \
		src/scene/x3d/auto_generated_node_helpers/*.inc \
		src/fonts/castletexturefont_*.pas \
		src/ui/castlecontrols_*.inc \

	touch prepare-source-stamp

# Annoying thing is we need to do this very early to save lots of overhead. If
# it can be done on a clean tree, right after prepare-source we don't need
# cleaning, right.
install-source: install-source-stamp
install-source-stamp:
	@echo "--- Copying the source code"
	dh_testdir
	${MKDIR} ${SRC_DIR}
	${CP} -t ${SRC_DIR} \
		$(CURDIR)/src/*
	# Remove statically linked libraries and object files from source packages
	find ${SRC_DIR} -name '*.a' -o -name '*.o' -o -name '*.obj' -delete
	# Fix files permission
	find $(SRC_DIR) -name '*.bmp' -o -name '*.pas' -exec chmod 644 '{}' ';'
	# Remove empty directories
	find ${SRC_DIR} -empty -delete
	touch install-source-stamp

override_dh_auto_build-arch: prepare-source install-source
	# Build the real engine
	${MAKE} build-using-fpmake tools
	# Generate man pages
	${MAKE} -C doc/man/man1

override_dh_auto_install-arch:
	# Install units
	${MKDIR} ${UNITS_DIR}
	${CP} -t ${UNITS_DIR} units/${FPCTARGET}/*
	# Mark package as manually compilable and install them
	for package in $$(find * -name '*.lpk') ; \
	do \
		pkgDir=$$(dirname "${LIB_DIR}/$${package}") ; \
		${MKDIR} "$${pkgDir}" ; \
		sed -e 's@\(\W*\)<CompilerOptions>.*@\1<AutoUpdate Value="Manually"/>\n&@' \
		    -e "s@\.\./src/@$$(relpath ${SRC_DIR} $${pkgDir})/@g" \
		    -e "s@\(\W*\)<UnitOutputDirectory .*@<UnitOutputDirectory Value=\"$$(relpath ${UNITS_DIR} $${pkgDir})\"/>@" \
		    "$${package}" > "${LIB_DIR}/$${package}" ; \
	done
	# Call upstream install target for the tools
	${MAKE} PREFIX=${INSTALL_DIR}/usr install
	# Install configration file so we can use: fpc @castle-game-engine progname
	${MKDIR} ${CFG_DIR}
	${CP} debian/castle-game-engine.cfg ${CFG_DIR}/castle-game-engine
	# Perform cleanup
	find ${INSTALL_DIR} -empty -delete

override_dh_auto_build-indep: prepare-source install-source
	@echo "--- Building Documentation"
	# Create logo first, before generating documentation
	${MAKE} -C doc/pasdoc/logo
	${MAKE} -C doc/pasdoc ${DOCTYPE}
	# pasdoc create a jquery file, but we link from jquery instead
	${RM} doc/reference/tipuesearch/jquery.min.js
	# Remove .npmignore file as Lintian complains about it.
	${RM} doc/reference/castle-engine-website-base/node_modules/slick-carousel/.npmignore
	# Remove windows executable files as Lintian complains about them.
	${RM} tools/contrib/x86_64-win64

override_dh_auto_install-indep: install-source

execute_before_dh_debputy:
	mkdir -p ${INSTALL_DIR}/packages
	echo 'If you are looking for CGE documentation, please install the package named' > ${INSTALL_DIR}/packages/README.txt
	echo 'castle-game-engine-doc.' >> ${INSTALL_DIR}/packages/README.txt

.PHONY:prepare-source install-source

## castle-game-engine 7.0~alpha.3+dfsg2

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,12 @@
 Uploaders:
  Abou Al Montacir <abou.almontacir@sfr.fr>,
  Paul Gevers <elbrus@debian.org>
-Standards-Version: 4.5.0
+Standards-Version: 4.7.0
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-debputy (>= 0.1.14~),
  fonts-dejavu,
- fp-compiler (>= 3.2.2+dfsg-35),
+ fp-compiler (>= 3.2.2+dfsg-40),
  fp-units-base,
  fp-units-db,
  fp-units-fcl,
@@ -30,7 +30,6 @@
  libgtk2.0-dev,
  libpango1.0-dev,
 Build-Depends-Indep:
- fonts-dejavu,
  pasdoc (>= 0.16.0~),
 Vcs-Git: https://salsa.debian.org/pascal-team/castle-game-engine.git
 Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine
@@ -39,6 +38,7 @@
 
 Package: fp-units-castle-game-engine
 Architecture: any
+Static-Built-Using: ${fpc:Static-Built-Using}
 Depends:
  ${fpc-abi:Depends},
  ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #!/usr/bin/make -f
 # debian/rules for Castle Game Engine
 
-include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
 export LANG:=C
@@ -27,9 +26,6 @@
 FPCTARGET=${CPU_TARGET}-${OS_TARGET}
 export CGE_VERSION=$(shell echo ${DEB_VERSION_UPSTREAM} | sed -e 's/^\([0-9\.]*\).*/\1/')
 DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
-ifndef PACKAGESUFFIX
-PACKAGESUFFIX=-${CGE_VERSION}
-endif
 # Get directories
 INSTALL_DIR=$(CURDIR)/debian/tmp
 CFG_DIR=${INSTALL_DIR}/etc/fpc-${FPCVER}.cfg.d
@@ -39,6 +35,11 @@
 TMP_DIR=${INSTALL_DIR}/tmp
 # Define units installation default directory as recommended by Debian FPC Team
 UNITS_DIR=${LIB_PREFIX}/${DEB_HOST_MULTIARCH}/${DEB_SOURCE}/fp-units/${FPCVER}
+
+# Set default compilation options
+BUILDOPTS=\
+	--compiler-option=@${CURDIR}/castle-fpc.cfg \
+
 # Get utils
 ifndef MKDIR
 MKDIR=mkdir -p
@@ -121,7 +122,7 @@
 
 override_dh_auto_build-arch: prepare-source install-source
 	# Build the real engine
-	${MAKE} build-using-fpmake tools
+	${MAKE} build-using-fpmake tools CASTLE_ENGINE_TOOL_OPTIONS='$(BUILDOPTS)'
 	# Generate man pages
 	${MAKE} -C doc/man/man1
 
@@ -146,6 +147,7 @@
 	${CP} debian/castle-game-engine.cfg ${CFG_DIR}/castle-game-engine
 	# Perform cleanup
 	find ${INSTALL_DIR} -empty -delete
+	fpc-depends
 
 override_dh_auto_build-indep: prepare-source install-source
 	@echo "--- Building Documentation"
@@ -167,3 +169,6 @@
 	echo 'castle-game-engine-doc.' >> ${INSTALL_DIR}/packages/README.txt
 
 .PHONY:prepare-source install-source
+
+lintian:
+	lintian -I -i ../${DEB_SOURCE}_${DEB_VERSION}.dsc
